/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM nsIAccessibleSelection.idl
 */

#ifndef __gen_nsIAccessibleSelection_h__
#define __gen_nsIAccessibleSelection_h__


#ifndef __gen_nsISupports_h__
#include "nsISupports.h"
#endif

#ifndef __gen_nsIAccessible_h__
#include "nsIAccessible.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif

/* starting interface:    nsIAccessibleSelection */
#define NS_IACCESSIBLESELECTION_IID_STR "94a1c5c2-25c2-46b3-bd0c-525d1d3e3346"

#define NS_IACCESSIBLESELECTION_IID \
  {0x94a1c5c2, 0x25c2, 0x46b3, \
    { 0xbd, 0x0c, 0x52, 0x5d, 0x1d, 0x3e, 0x33, 0x46 }}

class NS_NO_VTABLE nsIAccessibleSelection : public nsISupports {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_IACCESSIBLESELECTION_IID)

  /**
      * Returns the number of accessible children currently selected.
      */
  /* readonly attribute long selectionCount; */
  NS_IMETHOD GetSelectionCount(PRInt32 *aSelectionCount) = 0;

  /**
      * Adds the specified accessible child of the object to the
      * object's selection.
      */
  /* void addSelection (in long index); */
  NS_IMETHOD AddSelection(PRInt32 index) = 0;

  /**
      * Removes the specified child of the object from the object's selection.
      */
  /* void removeSelection (in long index); */
  NS_IMETHOD RemoveSelection(PRInt32 index) = 0;

  /**
      * Clears the selection in the object so that no children in the object
      * are selected.
      */
  /* void clearSelection (); */
  NS_IMETHOD ClearSelection(void) = 0;

  /**
      * Returns a reference to the accessible object representing the specified
      * selected child of the object.
      */
  /* nsIAccessible refSelection (in long index); */
  NS_IMETHOD RefSelection(PRInt32 index, nsIAccessible **_retval) = 0;

  /**
      * Determines if the current child of this object is selected
      */
  /* boolean isChildSelected (in long index); */
  NS_IMETHOD IsChildSelected(PRInt32 index, PRBool *_retval) = 0;

  /**
      * If the object does not accept multiple selection, return false.
      */
  /* boolean selectAllSelection (); */
  NS_IMETHOD SelectAllSelection(PRBool *_retval) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIACCESSIBLESELECTION \
  NS_IMETHOD GetSelectionCount(PRInt32 *aSelectionCount); \
  NS_IMETHOD AddSelection(PRInt32 index); \
  NS_IMETHOD RemoveSelection(PRInt32 index); \
  NS_IMETHOD ClearSelection(void); \
  NS_IMETHOD RefSelection(PRInt32 index, nsIAccessible **_retval); \
  NS_IMETHOD IsChildSelected(PRInt32 index, PRBool *_retval); \
  NS_IMETHOD SelectAllSelection(PRBool *_retval); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIACCESSIBLESELECTION(_to) \
  NS_IMETHOD GetSelectionCount(PRInt32 *aSelectionCount) { return _to GetSelectionCount(aSelectionCount); } \
  NS_IMETHOD AddSelection(PRInt32 index) { return _to AddSelection(index); } \
  NS_IMETHOD RemoveSelection(PRInt32 index) { return _to RemoveSelection(index); } \
  NS_IMETHOD ClearSelection(void) { return _to ClearSelection(); } \
  NS_IMETHOD RefSelection(PRInt32 index, nsIAccessible **_retval) { return _to RefSelection(index, _retval); } \
  NS_IMETHOD IsChildSelected(PRInt32 index, PRBool *_retval) { return _to IsChildSelected(index, _retval); } \
  NS_IMETHOD SelectAllSelection(PRBool *_retval) { return _to SelectAllSelection(_retval); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIACCESSIBLESELECTION(_to) \
  NS_IMETHOD GetSelectionCount(PRInt32 *aSelectionCount) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetSelectionCount(aSelectionCount); } \
  NS_IMETHOD AddSelection(PRInt32 index) { return !_to ? NS_ERROR_NULL_POINTER : _to->AddSelection(index); } \
  NS_IMETHOD RemoveSelection(PRInt32 index) { return !_to ? NS_ERROR_NULL_POINTER : _to->RemoveSelection(index); } \
  NS_IMETHOD ClearSelection(void) { return !_to ? NS_ERROR_NULL_POINTER : _to->ClearSelection(); } \
  NS_IMETHOD RefSelection(PRInt32 index, nsIAccessible **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->RefSelection(index, _retval); } \
  NS_IMETHOD IsChildSelected(PRInt32 index, PRBool *_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->IsChildSelected(index, _retval); } \
  NS_IMETHOD SelectAllSelection(PRBool *_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->SelectAllSelection(_retval); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsAccessibleSelection : public nsIAccessibleSelection
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIACCESSIBLESELECTION

  nsAccessibleSelection();
  virtual ~nsAccessibleSelection();
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsAccessibleSelection, nsIAccessibleSelection)

nsAccessibleSelection::nsAccessibleSelection()
{
  NS_INIT_ISUPPORTS();
  /* member initializers and constructor code */
}

nsAccessibleSelection::~nsAccessibleSelection()
{
  /* destructor code */
}

/* readonly attribute long selectionCount; */
NS_IMETHODIMP nsAccessibleSelection::GetSelectionCount(PRInt32 *aSelectionCount)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void addSelection (in long index); */
NS_IMETHODIMP nsAccessibleSelection::AddSelection(PRInt32 index)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void removeSelection (in long index); */
NS_IMETHODIMP nsAccessibleSelection::RemoveSelection(PRInt32 index)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void clearSelection (); */
NS_IMETHODIMP nsAccessibleSelection::ClearSelection()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsIAccessible refSelection (in long index); */
NS_IMETHODIMP nsAccessibleSelection::RefSelection(PRInt32 index, nsIAccessible **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* boolean isChildSelected (in long index); */
NS_IMETHODIMP nsAccessibleSelection::IsChildSelected(PRInt32 index, PRBool *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* boolean selectAllSelection (); */
NS_IMETHODIMP nsAccessibleSelection::SelectAllSelection(PRBool *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_nsIAccessibleSelection_h__ */
